__gnu_pbds::trie_prefix_search_node_update< Node_CItr, Node_Itr, _ATraits, _Alloc >(3cxx)

NAME
__gnu_pbds::trie_prefix_search_node_update< Node_CItr, Node_Itr, _ATraits, _Alloc > - A node updator that allows tries to be searched for the range of values that match a certain prefix.

SYNOPSIS

Inherits __gnu_pbds::detail::trie_policy_base< Node_CItr, Node_Itr, _ATraits, _Alloc >.

  Public Types

typedef access_traits::const_iterator a_const_iterator
Const element iterator.
typedef _ATraits access_traits
Element access traits.
typedef _Alloc allocator_type
_Alloc type.
typedef node_const_iterator::value_type const_iterator
typedef node_iterator::value_type iterator
typedef base_type::key_const_reference key_const_reference
typedef base_type::key_type key_type
typedef null_type metadata_type
typedef Node_CItr node_const_iterator
typedef Node_Itr node_iterator
typedef allocator_type::size_type size_type
Size type.

  Public Member Functions

std::pair< iterator, iterator > prefix_range (a_const_iterator, a_const_iterator)
Finds the iterator range corresponding to all values whose prefixes match [b, e).
std::pair< const_iterator, const_iterator > prefix_range (a_const_iterator, a_const_iterator) const
Finds the const iterator range corresponding to all values whose prefixes match [b, e).
std::pair< iterator, iterator > prefix_range (key_const_reference)
Finds the iterator range corresponding to all values whose prefixes match r_key.
std::pair< const_iterator, const_iterator > prefix_range (key_const_reference) const
Finds the const iterator range corresponding to all values whose prefixes match r_key.

  Protected Member Functions

void operator() (node_iterator node_it, node_const_iterator end_nd_it) const
Called to update a node's metadata.

Detailed Description

  template<typename Node_CItr, typename Node_Itr, typename _ATraits, typename _Alloc>
class __gnu_pbds::trie_prefix_search_node_update< Node_CItr, Node_Itr, _ATraits, _Alloc >" A node updator that allows tries to be searched for the range of values that match a certain prefix.

Member Typedef Documentation

  template<typename Node_CItr , typename Node_Itr , typename _ATraits , typename _Alloc > typedef access_traits::const_iterator __gnu_pbds::trie_prefix_search_node_update< Node_CItr, Node_Itr, _ATraits, _Alloc >::a_const_iterator

Const element iterator.

  template<typename Node_CItr , typename Node_Itr , typename _ATraits , typename _Alloc > typedef _ATraits __gnu_pbds::trie_prefix_search_node_update< Node_CItr, Node_Itr, _ATraits, _Alloc >::access_traits

Element access traits.

  template<typename Node_CItr , typename Node_Itr , typename _ATraits , typename _Alloc > typedef _Alloc __gnu_pbds::trie_prefix_search_node_update< Node_CItr, Node_Itr, _ATraits, _Alloc >::allocator_type

_Alloc type.

  template<typename Node_CItr , typename Node_Itr , typename _ATraits , typename _Alloc > typedef allocator_type::size_type __gnu_pbds::trie_prefix_search_node_update< Node_CItr, Node_Itr, _ATraits, _Alloc >::size_type

Size type.

Member Function Documentation

  template<typename Node_CItr , typename Node_Itr , typename _ATraits , typename _Alloc > void __gnu_pbds::trie_prefix_search_node_update< Node_CItr, Node_Itr, _ATraits, _Alloc >::operator() (node_iterator node_it, node_const_iterator end_nd_it) const [inline], [protected]

Called to update a node's metadata.

  template<typename Node_CItr , typename Node_Itr , typename _ATraits , typename _Alloc > std::pair<iterator, iterator> __gnu_pbds::trie_prefix_search_node_update< Node_CItr, Node_Itr, _ATraits, _Alloc >::prefix_range (a_const_iterator, a_const_iterator)

Finds the iterator range corresponding to all values whose prefixes match [b, e).

  template<typename Node_CItr , typename Node_Itr , typename _ATraits , typename _Alloc > std::pair<const_iterator, const_iterator> __gnu_pbds::trie_prefix_search_node_update< Node_CItr, Node_Itr, _ATraits, _Alloc >::prefix_range (a_const_iterator, a_const_iterator) const

Finds the const iterator range corresponding to all values whose prefixes match [b, e).

  template<typename Node_CItr , typename Node_Itr , typename _ATraits , typename _Alloc > std::pair<iterator, iterator> __gnu_pbds::trie_prefix_search_node_update< Node_CItr, Node_Itr, _ATraits, _Alloc >::prefix_range (key_const_reference)

Finds the iterator range corresponding to all values whose prefixes match r_key.

  template<typename Node_CItr , typename Node_Itr , typename _ATraits , typename _Alloc > std::pair<const_iterator, const_iterator> __gnu_pbds::trie_prefix_search_node_update< Node_CItr, Node_Itr, _ATraits, _Alloc >::prefix_range (key_const_reference) const

Finds the const iterator range corresponding to all values whose prefixes match r_key.

Author

Generated automatically by Doxygen for libstdc++ from the source code.